/*
 * Copyright 2020 Arne Vajh�j.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License. 
 */

#include <stdlib.h>
#include <string.h>

#include <descrip.h>
#include <dvidef.h>
#include <starlet.h>

typedef short int _int16;
typedef long int _int32;
typedef long long int _int64;

struct devinfo
{
    _int64 mount_time;
    _int32 freeblocks;
    _int32 serialnum;
    _int32 volsize;
    char alldevnam[16];
    char host_name[8];
    char volnam[16];
};

struct item
{
    _int16 buflen;
    _int16 code;
    void *bufadr;
    void *retlenadr;
};

#define ITEM(code,res) { sizeof(res), code, &res, NULL }

static struct devinfo di;

static struct item itmlst[] =
{
    ITEM(DVI$_ALLDEVNAM, di.alldevnam),
    ITEM(DVI$_FREEBLOCKS, di.freeblocks),
    ITEM(DVI$_HOST_NAME, di.host_name),
    ITEM(DVI$_MOUNT_TIME, di.mount_time),
    ITEM(DVI$_SERIALNUM, di.serialnum),
    ITEM(DVI$_VOLNAM, di.volnam),
    ITEM(DVI$_VOLSIZE, di.volsize)
};

#include "dvi.h"

int get_dvi_data(struct dsc$descriptor_s *devnam, char *buf, int buflen)
{
    memset(&di, 0, sizeof(di));
    sys$getdviw(0, 0, devnam, itmlst, 0, 0, 0, 0);
    int len = (buflen >= sizeof(di)) ? sizeof(di) : buflen;
    memcpy(buf, &di, len);
    return len;
}

